/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : ADC2.c
**     Project     : ProcessorExpert
**     Processor   : MK40DX256ZVLQ10
**     Component   : Init_ADC
**     Version     : Component 01.007, Driver 01.07, CPU db: 3.00.001
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2012-04-26, 16:01, # CodeGen: 93
**     Abstract    :
**          This file implements the ADC (ADC0) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
**     Settings    :
**          Component name                                 : ADC2
**          Device                                         : ADC0
**          Settings                                       : 
**            Clock gate                                   : Enabled
**            Clock settings                               : 
**              Input clock select                         : Bus clock
**              Prescaler                                  : 8
**              Frequency                                  : 6250 kHz
**              High-speed conversion                      : Disabled
**              Asynchro clock output                      : Disabled
**              Long sample time                           : Disabled
**              Long sample time length                    : 20 ADCK cycles
**            Conversion mode                              : Single
**            Result data format                           : 16-bit right
**            Low power mode                               : Disabled
**            Conversion trigger                           : HW
**            HW average settings                          : 
**              HW average                                 : Enabled
**              HW average length                          : 4 samples
**            Single conversion time - Single-ended        : 16.90 us
**            Single conversion time - Differential        : 22.66 us
**            Additional conversion time - Single-ended    : 16.00 us
**            Additional conversion time - Differential    : 21.76 us
**            Compare settings                             : 
**              Compare                                    : Disabled
**              Compare value 1                            : 0
**              Compare value 2                            : 0
**              Relation of the CV1 to CV2                 : Less than or equal
**              Compare function                           : Result < CV1
**            Voltage reference                            : Default pin pair
**          Pins/Signals                                   : 
**            Channel 0                                    : Disabled
**            Channel 1                                    : Disabled
**            Channel 2                                    : Disabled
**            Channel 3                                    : Disabled
**            Channel 4                                    : Disabled
**            Channel 5                                    : Disabled
**            Channel 6                                    : Disabled
**            Channel 7                                    : Disabled
**            Channel 8                                    : Disabled
**            Channel 9                                    : Disabled
**            Channel 10                                   : Enabled
**              Channel 10 single input                    : PTA7/FTM0_CH4/FB_AD18/TRACE_D3/ADC0_SE10
**              Channel 10 single input signal             : 
**            Channel 11                                   : Disabled
**            Channel 12                                   : Disabled
**            Channel 13                                   : Disabled
**            Channel 14                                   : Disabled
**            Channel 15                                   : Disabled
**            Channel 16                                   : Disabled
**            Channel 17                                   : Disabled
**            Channel 18                                   : Disabled
**            Channel 19                                   : Disabled
**            Channel 20                                   : Disabled
**            Channel 21                                   : Disabled
**            Channel 22                                   : Disabled
**            Channel 23                                   : Disabled
**            Channel 24                                   : Disabled
**            Channel 25                                   : Disabled
**            Channel 26                                   : Disabled
**            Channel 27                                   : Disabled
**            Channel 28                                   : Disabled
**            Channel 29                                   : Disabled
**            Channel 30                                   : Disabled
**            Trigger A                                    : Enabled
**              Trigger A source                           : PDB0_CH0_TriggerA
**              Trigger A source signal                    : 
**            Trigger B                                    : Disabled
**          Interrupts/DMA                                 : 
**            Interrupt                                    : INT_ADC0
**            Interrupt request                            : Disabled
**            Interrupt priority                           : 0 (Highest)
**            ISR name                                     : ADCinterrupt
**            Conversion complete A interrupt              : Enabled
**            Conversion complete B interrupt              : Disabled
**            DMA request                                  : Enabled
**          Initialization                                 : 
**            ADC part triggered  by trigger A             : 
**              Initial channel select A                   : Channel 10
**              Differential mode A                        : Disabled
**            ADC part triggered  by trigger B             : 
**              Initial channel select B                   : ADC disabled
**              Differential mode B                        : Disabled
**            Call Init method                             : no
**     Contents    :
**         Init - void ADC2_Init(void);
**
**     Copyright : 1997 - 2011 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE ADC2. */

#include "ADC2.h"
  /* Including shared modules, which are used in the whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Cpu.h"


/*
** ===================================================================
**     Method      :  ADC2_Init (component Init_ADC)
**
**     Description :
**         This method initializes registers of the ADC module
**         according to the Peripheral Initialization settings.
**         Call this method in user code to initialize the module. By
**         default, the method is called by PE automatically; see "Call
**         Init method" property of the component for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void ADC2_Init(void)
{
  /* SIM_SCGC6: ADC0=1 */
  SIM_SCGC6 |= (uint32_t)0x08000000UL;                       
  /* ADC0_CFG1: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,ADLPC=0,ADIV=3,ADLSMP=0,MODE=3,ADICLK=0 */
  ADC0_CFG1 = (uint32_t)0x6CUL;                  
  /* ADC0_CFG2: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,ADACKEN=0,ADHSC=0,ADLSTS=0 */
  ADC0_CFG2 &= (uint32_t)~0xFFFFFFEFUL;                      
  /* ADC0_CV1: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,CV=0 */
  ADC0_CV1 = (uint32_t)0x00UL;                  
  /* ADC0_CV2: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,CV=0 */
  ADC0_CV2 = (uint32_t)0x00UL;                  
  /* ADC0_SC2: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,ADACT=0,ADTRG=1,ACFE=0,ACFGT=0,ACREN=0,DMAEN=1,REFSEL=0 */
  ADC0_SC2 = (uint32_t)0x44UL;                  
  /* ADC0_SC3: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,CAL=0,CALF=0,??=0,??=0,ADCO=0,AVGE=1,AVGS=0 */
  ADC0_SC3 = (uint32_t)0x04UL;                  
  /* ADC0_SC1A: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,COCO=0,AIEN=1,DIFF=0,ADCH=0x0A */
  ADC0_SC1A = (uint32_t)0x4AUL;                  
  /* ADC0_SC1B: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,COCO=0,AIEN=0,DIFF=0,ADCH=0x1F */
  ADC0_SC1B = (uint32_t)0x1FUL;                  
}

/*
** ###################################################################
**
**  The interrupt service routine(s) must be implemented
**  by user in one of the following user modules.
**
**  If the "Generate ISR" option is enabled, Processor Expert generates
**  ISR templates in the CPU event module.
**
**  User modules:
**      ProcessorExpert.c
**      Events.c
**
** ###################################################################
PE_ISR(ADCinterrupt)
{
// NOTE: The routine should include actions to clear the appropriate
//       interrupt flags.
//
}
*/


/* END ADC2. */
/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
